:: standard P2J interactive client startup script
@echo off
:: defaults
set cfgdir=%~dp0
if %cfgdir:~-1% == \ (SET cfgdir=%cfgdir:~,-1%)

set up=..\..\..\..
:: To turn off debugging set debug=0
set debug=2090
set suspend="n"
set prog=java -Dfile.encoding="UTF-8"
set dump=-XX:+HeapDumpOnOutOfMemoryError
set swing=client:driver:type=swing_chui_frame client:chui:rows=24 client:chui:columns=80 client:chui:background=0x000000 client:chui:foreground=0xFFA500 client:chui:selection=0x0000FF client:chui:fontname="Lucida Sans Typewriter" client:chui:fontsize=12
set host="net:server:host=localhost"
set cfg=""
::set logdir=%P2J_LOG_DIR%
set logdir=""
set log=""
set srvr=
set test="n"
set codepath=""
set instance=0

:: help text
set usage[0]="\nUsage: %0 [-dport] [-s] [-t] [-llogfile] [-ccfgfile] [-iinstance] [-2] [-zcodepath]\n"
set usage[1]="Where:\n"
set usage[2]="d \t= enable JVM debug mode, use the specified TCP port"
set usage[3]="s \t= in JVM debug mode enable, suspend the JVM on startup (does not suspend by default)"
set usage[4]="t \t= test mode (displays the command but doesn't execute)"
set usage[5]="l \t= log file name in your home dir (all STDERR is redirected to this file, defaults to stderr.log)"
set usage[6]="h \t= hostname or IP address for the server (defaults to localhost)"
set usage[7]="i \t= server instance number (0..9, assigns the P2J server port, defaults to 0) to which to connect"
set usage[8]="c \t= config file name (P2J bootstrap config file name, defaults to standard_client.xml)"
set usage[9]="2 \t= enable C2 HotSpot compiler (server compiler for the JVM)"
set usage[10]="z \t= specify the path (with no trailing slash) to the location of the p2j.jar, libTerminal.so and libp2j.so"

:: process options
::if %1 == -? (for /l %%G in (0,1,10) do echo %usage[%%G]% )

:: Getting the current date
set _c_date=%date%
set _c_date=%_c_date: =_%
set _c_date=%_c_date::=%
set _c_date=%_c_date:/=_%
set _c_date=%_c_date:.=_%

:: Getting the current time
for /f "tokens=1-3 delims=1234567890 " %%a in ("%time%") do set "delims=%%a%%b%%c"
for /f "tokens=1-4 delims=%delims%" %%G in ("%time%") do (
  set _hh=%%G
  set _min=%%H
  set _ss=%%I
  set _ms=%%J
)
:: Strip any leading spaces
set _hh=%_hh: =%

:: Ensure the hours have a leading zero
if 1%_hh% LSS 20 set _hh=0%_hh%

:: final arg prep
set port="net:server:insecure_port=3333"

if %debug% neq 0 (set dtxt=-Xdebug -Xnoagent -Djava.compiler=NONE -Xrunjdwp:transport=dt_socket,address=%debug%,server=y,suspend=%suspend%) else (set dtxt= )
if %logdir% == "" (set logdir=.)
if %log% == "" (set log=%logdir%\client_%USERNAME%_%_c_date%_%_hh%%_min%%_ss%%_ms%.log )
if %codepath% == "" (set codepath=%cfgdir%\%up%\p2j\build\lib)

set cfg=%cfgdir%\%cfg%
set lpath=-Djava.library.path=%codepath%\
set cpath=-classpath %codepath%\p2j.jar

:: run the P2J client
set cmd=CMD.EXE /C %prog% %srvr% %dump% %dtxt% %lpath% %cpath% com.goldencode.p2j.main.ClientDriver %host% %port% %swing%
if %test% == "y" (%cmd%) else (%cmd% 2>%log%)
