:: standard P2J server startup script
@echo off
:: defaults
set cpath=..\..\..\build\lib\p2jadmin.jar;..\..\..\build\lib\p2j.jar
set debug=0
set suspend="n"
set hprof=""
set prog=java -Dfile.encoding="UTF-8"
set srvr=-server
set heap=768
set outlog=stdout.log
set errlog=server.log
set cfg=server.xml
set port=""
set mode=""
set statcode="n"
set instance=0
set usage[0]="\nUsage: $0 [-dyptksw1] [-zcp] [-hheap] [-llog] [-ccfg] [-iinst]\n"
set usage[1]="Where:\n"
set usage[2]="d \t= enable JVM debug mode (debugger port will be set as 2080 + instance #)"
set usage[3]="y \t= in JVM debug mode enable, suspend the JVM on startup (does not suspend by default)"
set usage[4]="p \t= enable JVM hprof (profiling output to gc.log)"
set usage[5]="t \t= test mode (displays the command but doesn't execute)"
set usage[6]="k \t= kill mode (shuts down the specified/default instance)"
set usage[7]="s \t= status mode (displays the status of the specified/default instance)"
set usage[8]="w \t= wait mode (does not return until the specified/default instance is STATUS_RUNNING)"
set usage[9]="1 \t= enable C1 HotSpot compiler (client compiler for the JVM)"
set usage[10]="cp \t= override the classpath which would otherwise be set to $cpath"
set usage[11]="heap \t= set JVM max heap size (must be an integer number of MB)"
set usage[12]="log \t= log file name (all STDERR is redirected to this file, defaults to ./server.log)"
set usage[13]="cfg \t= config file name (P2J bootstrap config file name, defaults to server.xml)"
set usage[14]="inst \t= server instance number (0..9, assigns the P2J server port, defaults to 0)\n"

:: process options

:: final arg prep
set cpath=-classpath %cpath%
set dport=(2080 + %instance%)
set port="net:server:insecure_port=3333"

if %debug% equ 1 ( set dtxt="-Xdebug -Xnoagent -Djava.compiler=NONE -Xrunjdwp:transport=dt_socket,address=%dport%,server=y,suspend=%suspend%" ) else ( set dtxt="" )

set maxheap=-XX:MaxPermSize=128m -Xmx%heap%m

:: run the P2J server
CMD.EXE /C %prog% %maxheap% %srvr% %cpath% com.goldencode.p2j.main.ServerDriver %cfg% %port% 1>%outlog% 2>%errlog%
